-#!/usr/bin/perl
+#!/usr/bin/env perl
use FindBin;
use lib "$FindBin::Bin";
use strict;
sub parse_target_metadata() {
my $file = shift @ARGV;
my ($target, @target, $profile);
+ my %target;
+
open FILE, "<$file" or do {
warn "Can't open file '$file': $!\n";
return;
while (<FILE>) {
chomp;
/^Target:\s*(.+)\s*$/ and do {
+ my $name = $1;
$target = {
- id => $1,
- conf => confstr($1),
- profiles => []
+ id => $name,
+ board => $name,
+ boardconf => confstr($name),
+ conf => confstr($name),
+ profiles => [],
+ features => [],
+ depends => [],
+ subtargets => []
};
push @target, $target;
+ $target{$name} = $target;
+ if ($name =~ /([^\/]+)\/([^\/]+)/) {
+ push @{$target{$1}->{subtargets}}, $2;
+ $target->{board} = $1;
+ $target->{boardconf} = confstr($1);
+ $target->{subtarget} = 1;
+ $target->{parent} = $target{$1};
+ }
};
- /^Target-Board:\s*(.+)\s*$/ and do {
- $target->{board} = $1;
- $target->{boardconf} = confstr($1);
- };
- /^Target-Kernel:\s*(\d+\.\d+)\s*$/ and $target->{kernel} = $1;
/^Target-Name:\s*(.+)\s*$/ and $target->{name} = $1;
/^Target-Path:\s*(.+)\s*$/ and $target->{path} = $1;
/^Target-Arch:\s*(.+)\s*$/ and $target->{arch} = $1;
+ /^Target-Arch-Packages:\s*(.+)\s*$/ and $target->{arch_packages} = $1;
/^Target-Features:\s*(.+)\s*$/ and $target->{features} = [ split(/\s+/, $1) ];
+ /^Target-Depends:\s*(.+)\s*$/ and $target->{depends} = [ split(/\s+/, $1) ];
/^Target-Description:/ and $target->{desc} = get_multiline(*FILE);
+ /^Target-Optimization:\s*(.+)\s*$/ and $target->{cflags} = $1;
/^Linux-Version:\s*(.+)\s*$/ and $target->{version} = $1;
/^Linux-Release:\s*(.+)\s*$/ and $target->{release} = $1;
/^Linux-Kernel-Arch:\s*(.+)\s*$/ and $target->{karch} = $1;
+ /^Default-Subtarget:\s*(.+)\s*$/ and $target->{def_subtarget} = $1;
/^Default-Packages:\s*(.+)\s*$/ and $target->{packages} = [ split(/\s+/, $1) ];
/^Target-Profile:\s*(.+)\s*$/ and do {
$profile = {
}
close FILE;
foreach my $target (@target) {
+ next if @{$target->{subtargets}} > 0;
@{$target->{profiles}} > 0 or $target->{profiles} = [
{
id => 'Default',
while ($_ = shift @_) {
/broken/ and $ret .= "\tdepends BROKEN\n";
+ /audio/ and $ret .= "\tselect AUDIO_SUPPORT\n";
+ /display/ and $ret .= "\tselect DISPLAY_SUPPORT\n";
+ /gpio/ and $ret .= "\tselect GPIO_SUPPORT\n";
/pci/ and $ret .= "\tselect PCI_SUPPORT\n";
+ /pcie/ and $ret .= "\tselect PCIE_SUPPORT\n";
/usb/ and $ret .= "\tselect USB_SUPPORT\n";
+ /usbgadget/ and $ret .= "\tselect USB_GADGET_SUPPORT\n";
/pcmcia/ and $ret .= "\tselect PCMCIA_SUPPORT\n";
/squashfs/ and $ret .= "\tselect USES_SQUASHFS\n";
/jffs2/ and $ret .= "\tselect USES_JFFS2\n";
- /ext2/ and $ret .= "\tselect USES_EXT2\n";
- /tgz/ and $ret .= "\tselect USES_TGZ\n";
+ /ext4/ and $ret .= "\tselect USES_EXT4\n";
+ /targz/ and $ret .= "\tselect USES_TARGZ\n";
+ /cpiogz/ and $ret .= "\tselect USES_CPIOGZ\n";
+ /ubifs/ and $ret .= "\tselect USES_UBIFS\n";
+ /fpu/ and $ret .= "\tselect HAS_FPU\n";
+ /spe_fpu/ and $ret .= "\tselect HAS_SPE_FPU\n";
+ /ramdisk/ and $ret .= "\tselect USES_INITRAMFS\n";
+ /powerpc64/ and $ret .= "\tselect powerpc64\n";
+ /nommu/ and $ret .= "\tselect NOMMU\n";
}
return $ret;
}
+sub target_name($) {
+ my $target = shift;
+ my $parent = $target->{parent};
+ if ($parent) {
+ return $target->{parent}->{name}." - ".$target->{name};
+ } else {
+ return $target->{name};
+ }
+}
+
+sub kver($) {
+ my $v = shift;
+ $v =~ tr/\./_/;
+ if (substr($v,0,2) eq "2_") {
+ $v =~ /(\d+_\d+_\d+)(_\d+)?/ and $v = $1;
+ } else {
+ $v =~ /(\d+_\d+)(_\d+)?/ and $v = $1;
+ }
+ return $v;
+}
+
+sub print_target($) {
+ my $target = shift;
+ my $features = target_config_features(@{$target->{features}});
+ my $help = $target->{desc};
+ my $confstr;
+
+ chomp $features;
+ $features .= "\n";
+ if ($help =~ /\w+/) {
+ $help =~ s/^\s*/\t /mg;
+ $help = "\thelp\n$help";
+ } else {
+ undef $help;
+ }
+
+ my $v = kver($target->{version});
+ if (@{$target->{subtargets}} == 0) {
+ $confstr = <<EOF;
+config TARGET_$target->{conf}
+ bool "$target->{name}"
+ select LINUX_$v
+EOF
+ }
+ else {
+ $confstr = <<EOF;
+config TARGET_$target->{conf}
+ bool "$target->{name}"
+EOF
+ }
+ if ($target->{subtarget}) {
+ $confstr .= "\tdepends TARGET_$target->{boardconf}\n";
+ }
+ if (@{$target->{subtargets}} > 0) {
+ $confstr .= "\tselect HAS_SUBTARGETS\n";
+ } else {
+ $confstr .= $features;
+ }
+
+ if ($target->{arch} =~ /\w/) {
+ $confstr .= "\tselect $target->{arch}\n";
+ }
+ foreach my $dep (@{$target->{depends}}) {
+ my $mode = "depends";
+ my $flags;
+ my $name;
+
+ $dep =~ /^([@\+\-]+)(.+)$/;
+ $flags = $1;
+ $name = $2;
+
+ next if $name =~ /:/;
+ $flags =~ /-/ and $mode = "deselect";
+ $flags =~ /\+/ and $mode = "select";
+ $flags =~ /@/ and $confstr .= "\t$mode $name\n";
+ }
+ $confstr .= "$help\n\n";
+ print $confstr;
+}
sub gen_target_config() {
my @target = parse_target_metadata();
+ my %defaults;
- @target = sort {
- $a->{name} cmp $b->{name}
+ my @target_sort = sort {
+ target_name($a) cmp target_name($b);
} @target;
-
-
+
+
print <<EOF;
choice
prompt "Target System"
- default TARGET_brcm_2_4
+ default TARGET_brcm47xx
reset if !DEVEL
EOF
- foreach my $target (@target) {
- my $features = target_config_features(@{$target->{features}});
- my $help = $target->{desc};
- my $kernel = $target->{kernel};
- $kernel =~ tr/./_/;
-
- chomp $features;
- $features .= "\n";
- if ($help =~ /\w+/) {
- $help =~ s/^\s*/\t /mg;
- $help = "\thelp\n$help";
- } else {
- undef $help;
- }
-
- print <<EOF;
-config TARGET_$target->{conf}
- bool "$target->{name}"
- select $target->{arch}
- select LINUX_$kernel
-EOF
- if ($target->{id} ne $target->{board}) {
- print "\tselect TARGET_".$target->{boardconf}."\n";
- }
- print "$features$help\n\n"
+ foreach my $target (@target_sort) {
+ next if $target->{subtarget};
+ print_target($target);
}
print <<EOF;
endchoice
-config TARGET_BOARD
- string
+choice
+ prompt "Subtarget" if HAS_SUBTARGETS
EOF
foreach my $target (@target) {
- print "\t\tdefault \"".$target->{board}."\" if TARGET_".$target->{conf}."\n";
+ next unless $target->{def_subtarget};
+ print <<EOF;
+ default TARGET_$target->{conf}_$target->{def_subtarget} if TARGET_$target->{conf}
+EOF
}
+ print <<EOF;
- # add hidden target config options
+EOF
foreach my $target (@target) {
- next if $board{$target->{board}};
- if ($target->{id} ne $target->{board}) {
- print "\nconfig TARGET_".$target->{boardconf}."\n\tbool\n";
- $board{$target->{board}} = 1;
- }
+ next unless $target->{subtarget};
+ print_target($target);
}
- print <<EOF;
+
+print <<EOF;
+endchoice
choice
prompt "Target Profile"
EOF
-
+
foreach my $target (@target) {
my $profiles = $target->{profiles};
-
+
foreach my $profile (@$profiles) {
print <<EOF;
config TARGET_$target->{conf}_$profile->{id}
my @pkglist = merge_package_lists($target->{packages}, $profile->{packages});
foreach my $pkg (@pkglist) {
print "\tselect DEFAULT_$pkg\n";
+ $defaults{$pkg} = 1;
}
- print "\n";
+ my $help = $profile->{desc};
+ if ($help =~ /\w+/) {
+ $help =~ s/^\s*/\t /mg;
+ $help = "\thelp\n$help";
+ } else {
+ undef $help;
+ }
+ print "$help\n";
}
}
- print "endchoice\n";
+ print <<EOF;
+endchoice
+
+config HAS_SUBTARGETS
+ bool
+
+config TARGET_BOARD
+ string
+
+EOF
+ foreach my $target (@target) {
+ $target->{subtarget} or print "\t\tdefault \"".$target->{board}."\" if TARGET_".$target->{conf}."\n";
+ }
+ print <<EOF;
+config TARGET_ARCH_PACKAGES
+ string
+
+EOF
+ foreach my $target (@target) {
+ next if @{$target->{subtargets}} > 0;
+ print "\t\tdefault \"".($target->{arch_packages} || $target->{board})."\" if TARGET_".$target->{conf}."\n";
+ }
+ print <<EOF;
+
+config DEFAULT_TARGET_OPTIMIZATION
+ string
+EOF
+ foreach my $target (@target) {
+ next if @{$target->{subtargets}} > 0;
+ print "\tdefault \"".$target->{cflags}."\" if TARGET_".$target->{conf}."\n";
+ }
+ print "\tdefault \"-Os -pipe -funit-at-a-time\"\n";
+
+ my %kver;
+ foreach my $target (@target) {
+ my $v = kver($target->{version});
+ next if $kver{$v};
+ $kver{$v} = 1;
+ print <<EOF;
+
+config LINUX_$v
+ bool
+
+EOF
+ }
+ foreach my $def (sort keys %defaults) {
+ print "\tconfig DEFAULT_".$def."\n";
+ print "\t\tbool\n\n";
+ }
}
my %dep_check;
return $ret;
}
-sub mconf_depends($$) {
+sub mconf_depends {
+ my $pkgname = shift;
my $depends = shift;
my $only_dep = shift;
my $res;
+ my $dep = shift;
+ my $seen = shift;
+ my $parent_condition = shift;
+ $dep or $dep = {};
+ $seen or $seen = {};
$depends or return;
my @depends = @$depends;
foreach my $depend (@depends) {
my $m = "depends";
- $depend =~ s/^([@\+]+)//;
- my $flags = $1;
+ my $flags = "";
+ $depend =~ s/^([@\+]+)// and $flags = $1;
my $vdep;
-
+ my $condition = $parent_condition;
+
+ next if $condition eq $depend;
+ next if $seen->{"$parent_condition:$depend"};
+ $seen->{"$parent_condition:$depend"} = 1;
+ if ($depend =~ /^(.+):(.+)$/) {
+ if ($1 ne "PACKAGE_$pkgname") {
+ if ($condition) {
+ $condition = "$condition && $1";
+ } else {
+ $condition = $1;
+ }
+ }
+ $depend = $2;
+ }
+ next if $package{$depend} and $package{$depend}->{buildonly};
if ($vdep = $package{$depend}->{vdepends}) {
$depend = join("||", map { "PACKAGE_".$_ } @$vdep);
} else {
$flags =~ /\+/ and do {
- next if $only_dep;
- $m = "select";
-
# Menuconfig will not treat 'select FOO' as a real dependency
# thus if FOO depends on other config options, these dependencies
# will not be checked. To fix this, we simply emit all of FOO's
# depends here as well.
- $package{$depend} and $res .= mconf_depends($package{$depend}->{depends}, 1);
+ $package{$depend} and mconf_depends($pkgname, $package{$depend}->{depends}, 1, $dep, $seen, $condition);
+
+ $m = "select";
+ next if $only_dep;
};
$flags =~ /@/ or $depend = "PACKAGE_$depend";
+ if ($condition) {
+ if ($m =~ /select/) {
+ next if $depend eq $condition;
+ $depend = "$depend if $condition";
+ } else {
+ $depend = "!($condition) || $depend";
+ }
+ }
}
+ $dep->{$depend} =~ /select/ or $dep->{$depend} = $m;
+ }
+ foreach my $depend (keys %$dep) {
+ my $m = $dep->{$depend};
$res .= "\t\t$m $depend\n";
}
return $res;
my $cat = shift;
my %menus;
my %menu_dep;
-
+
return unless $category{$cat};
-
+
print "menu \"$cat\"\n\n";
my %spkg = %{$category{$cat}};
-
+
foreach my $spkg (sort {uc($a) cmp uc($b)} keys %spkg) {
foreach my $pkg (@{$spkg{$spkg}}) {
+ next if $pkg->{buildonly};
my $menu = $pkg->{submenu};
if ($menu) {
$menu_dep{$menu} or $menu_dep{$menu} = $pkg->{submenudep};
}
$menus{$menu} or $menus{$menu} = [];
push @{$menus{$menu}}, $pkg;
- print "\tconfig DEFAULT_".$pkg->{name}."\n";
- print "\t\tbool\n\n";
}
}
my @menus = sort {
if ($c > 0) {
$title .= ("." x $c). " ". $pkg->{title};
}
+ $title = "\"$title\"";
print "\t";
$pkg->{menu} and print "menu";
print "config PACKAGE_".$pkg->{name}."\n";
- print "\t\t".($pkg->{tristate} ? 'tristate' : 'bool')." \"$title\"\n";
+ $pkg->{hidden} and $title = "";
+ print "\t\t".($pkg->{tristate} ? 'tristate' : 'bool')." $title\n";
print "\t\tdefault y if DEFAULT_".$pkg->{name}."\n";
foreach my $default (split /\s*,\s*/, $pkg->{default}) {
print "\t\tdefault $default\n";
}
- print mconf_depends($pkg->{depends}, 0);
+ print mconf_depends($pkg->{name}, $pkg->{depends}, 0);
+ print mconf_depends($pkg->{name}, $pkg->{mdepends}, 0);
print "\t\thelp\n";
print $pkg->{description};
print "\n";
}
}
print "endmenu\n\n";
-
+
undef $category{$cat};
}
+sub print_package_features() {
+ keys %features > 0 or return;
+ print "menu \"Package features\"\n";
+ foreach my $n (keys %features) {
+ my @features = sort { $b->{priority} <=> $a->{priority} or $a->{title} cmp $b->{title} } @{$features{$n}};
+ print <<EOF;
+choice
+ prompt "$features[0]->{target_title}"
+ default FEATURE_$features[0]->{name}
+EOF
+
+ foreach my $feature (@features) {
+ print <<EOF;
+ config FEATURE_$feature->{name}
+ bool "$feature->{title}"
+EOF
+ $feature->{description} =~ /\w/ and do {
+ print "\t\thelp\n".$feature->{description}."\n";
+ };
+ }
+ print "endchoice\n"
+ }
+ print "endmenu\n\n";
+}
+
sub gen_package_config() {
parse_package_metadata($ARGV[0]) or exit 1;
- print "menuconfig UCI_PRECONFIG\n\tbool \"Image configuration\"\n";
+ print "menuconfig IMAGEOPT\n\tbool \"Image configuration\"\n\tdefault n\n";
foreach my $preconfig (keys %preconfig) {
foreach my $cfg (keys %{$preconfig{$preconfig}}) {
my $conf = $preconfig{$preconfig}->{$cfg}->{id};
$conf =~ tr/\.-/__/;
print <<EOF
config UCI_PRECONFIG_$conf
- string "$preconfig{$preconfig}->{$cfg}->{label}" if UCI_PRECONFIG
+ string "$preconfig{$preconfig}->{$cfg}->{label}" if IMAGEOPT
depends PACKAGE_$preconfig
default "$preconfig{$preconfig}->{$cfg}->{default}"
EOF
}
}
+ print "source \"package/*/image-config.in\"\n";
+ if (scalar glob "package/feeds/*/*/image-config.in") {
+ print "source \"package/feeds/*/*/image-config.in\"\n";
+ }
+ print_package_features();
print_package_config_category 'Base system';
foreach my $cat (keys %category) {
print_package_config_category $cat;
}
}
+sub get_conditional_dep($$) {
+ my $condition = shift;
+ my $depstr = shift;
+ if ($condition) {
+ if ($condition =~ /^!(.+)/) {
+ return "\$(if \$(CONFIG_$1),,$depstr)";
+ } else {
+ return "\$(if \$(CONFIG_$condition),$depstr)";
+ }
+ } else {
+ return $depstr;
+ }
+}
+
sub gen_package_mk() {
my %conf;
my %dep;
+ my %done;
my $line;
parse_package_metadata($ARGV[0]) or exit 1;
foreach my $name (sort {uc($a) cmp uc($b)} keys %package) {
my $config;
my $pkg = $package{$name};
-
+ my @srcdeps;
+
next if defined $pkg->{vdepends};
+
if ($ENV{SDK}) {
$conf{$pkg->{src}} or do {
$config = 'm';
$config = "\$(CONFIG_PACKAGE_$name)"
}
if ($config) {
+ $pkg->{buildonly} and $config = "";
print "package-$config += $pkg->{subdir}$pkg->{src}\n";
+ if ($pkg->{variant}) {
+ if (!defined($done{$pkg->{src}})) {
+ print "\$(curdir)/$pkg->{subdir}$pkg->{src}/default-variant := $pkg->{variant}\n";
+ }
+ print "\$(curdir)/$pkg->{subdir}$pkg->{src}/variants += \$(if $config,$pkg->{variant})\n"
+ }
$pkg->{prereq} and print "prereq-$config += $pkg->{subdir}$pkg->{src}\n";
}
-
+
+ next if $done{$pkg->{src}};
+ $done{$pkg->{src}} = 1;
+
+ if (@{$pkg->{buildtypes}} > 0) {
+ print "buildtypes-$pkg->{subdir}$pkg->{src} = ".join(' ', @{$pkg->{buildtypes}})."\n";
+ }
+
+ foreach my $spkg (@{$srcpackage{$pkg->{src}}}) {
+ foreach my $dep (@{$spkg->{depends}}, @{$spkg->{builddepends}}) {
+ $dep =~ /@/ or do {
+ $dep =~ s/\+//g;
+ push @srcdeps, $dep;
+ };
+ }
+ }
+ foreach my $type (@{$pkg->{buildtypes}}) {
+ my @extra_deps;
+ my %deplines;
+
+ next unless $pkg->{"builddepends/$type"};
+ foreach my $dep (@{$pkg->{"builddepends/$type"}}) {
+ my $suffix = "";
+ my $condition;
+
+ if ($dep =~ /^(.+):(.+)/) {
+ $condition = $1;
+ $dep = $2;
+ }
+ if ($dep =~ /^(.+)(\/.+)/) {
+ $dep = $1;
+ $suffix = $2;
+ }
+
+ my $idx = "";
+ my $pkg_dep = $package{$dep};
+ if (defined($pkg_dep) && defined($pkg_dep->{src})) {
+ $idx = $pkg_dep->{subdir}.$pkg_dep->{src};
+ } elsif (defined($srcpackage{$dep})) {
+ $idx = $subdir{$dep}.$dep;
+ } else {
+ next;
+ }
+ my $depstr = "\$(curdir)/$idx$suffix/compile";
+ my $depline = get_conditional_dep($condition, $depstr);
+ if ($depline) {
+ $deplines{$depline}++;
+ }
+ }
+ my $depline = join(" ", sort keys %deplines);
+ if ($depline) {
+ $line .= "\$(curdir)/".$pkg->{subdir}."$pkg->{src}/$type/compile += $depline\n";
+ }
+ }
+
my $hasdeps = 0;
- my $depline = "";
- foreach my $dep (@{$pkg->{depends}}, @{$pkg->{builddepends}}) {
- next if $dep =~ /@/;
- $dep =~ s/\+//;
+ my %deplines;
+ foreach my $deps (@srcdeps) {
my $idx;
- my $pkg_dep = $package{$dep};
- next if defined $pkg_dep->{vdepends};
+ my $condition;
+ my $prefix = "";
+ my $suffix = "";
- if (defined $pkg_dep->{src}) {
- ($pkg->{src} ne $pkg_dep->{src}) and $idx = $pkg_dep->{subdir}.$pkg_dep->{src};
- } elsif (defined($srcpackage{$dep})) {
- $idx = $subdir{$dep}.$dep;
+ if ($deps =~ /^(.+):(.+)/) {
+ $condition = $1;
+ $deps = $2;
}
- undef $idx if $idx =~ /^(kernel)|(base-files)$/;
- if ($idx) {
- next if $dep{$pkg->{src}."->".$idx};
- $depline .= " \$(curdir)/$idx/compile";
- $dep{$pkg->{src}."->".$idx} = 1;
+ if ($deps =~ /^(.+)(\/.+)/) {
+ $deps = $1;
+ $suffix = $2;
+ }
+
+ my $pkg_dep = $package{$deps};
+ my @deps;
+
+ if ($pkg_dep->{vdepends}) {
+ @deps = @{$pkg_dep->{vdepends}};
+ } else {
+ @deps = ($deps);
+ }
+
+ foreach my $dep (@deps) {
+ $pkg_dep = $package{$deps};
+ if (defined $pkg_dep->{src}) {
+ ($pkg->{src} ne $pkg_dep->{src}.$suffix) and $idx = $pkg_dep->{subdir}.$pkg_dep->{src};
+ } elsif (defined($srcpackage{$dep})) {
+ $idx = $subdir{$dep}.$dep;
+ }
+ $idx .= $suffix;
+ undef $idx if $idx =~ /^(kernel)|(base-files)$/;
+ if ($idx) {
+ my $depline;
+ next if $pkg->{src} eq $pkg_dep->{src}.$suffix;
+ next if $dep{$condition.":".$pkg->{src}."->".$idx};
+ next if $dep{$pkg->{src}."->($dep)".$idx} and $pkg_dep->{vdepends};
+ my $depstr;
+
+ if ($pkg_dep->{vdepends}) {
+ $depstr = "\$(if \$(CONFIG_PACKAGE_$dep),\$(curdir)/$idx/compile)";
+ $dep{$pkg->{src}."->($dep)".$idx} = 1;
+ } else {
+ $depstr = "\$(curdir)/$idx/compile";
+ $dep{$pkg->{src}."->".$idx} = 1;
+ }
+ $depline = get_conditional_dep($condition, $depstr);
+ if ($depline) {
+ $deplines{$depline}++;
+ }
+ }
}
}
+ my $depline = join(" ", sort keys %deplines);
if ($depline) {
$line .= "\$(curdir)/".$pkg->{subdir}."$pkg->{src}/compile += $depline\n";
}
}
-
+
if ($line ne "") {
print "\n$line";
}
next unless $cmds;
print <<EOF
+ifndef DUMP_TARGET_DB
\$(TARGET_DIR)/etc/uci-defaults/$preconfig: FORCE
( \\
$cmds \\
) > \$@
-ifneq (\$(UCI_PRECONFIG)\$(CONFIG_UCI_PRECONFIG),)
+ifneq (\$(IMAGEOPT)\$(CONFIG_IMAGEOPT),)
package/preconfig: \$(TARGET_DIR)/etc/uci-defaults/$preconfig
endif
+endif
+
EOF
}
}
+sub gen_package_source() {
+ parse_package_metadata($ARGV[0]) or exit 1;
+ foreach my $name (sort {uc($a) cmp uc($b)} keys %package) {
+ my $pkg = $package{$name};
+ if ($pkg->{name} && $pkg->{source}) {
+ print "$pkg->{name}: ";
+ print "$pkg->{source}\n";
+ }
+ }
+}
sub parse_command() {
my $cmd = shift @ARGV;
/^package_mk$/ and return gen_package_mk();
/^package_config$/ and return gen_package_config();
/^kconfig/ and return gen_kconfig_overrides();
+ /^package_source$/ and return gen_package_source();
}
print <<EOF
Available Commands:
$0 target_config [file] Target metadata in Kconfig format
- $0 package_mk [file] Package metadata in makefile format
+ $0 package_mk [file] Package metadata in makefile format
$0 package_config [file] Package metadata in Kconfig format
$0 kconfig [file] [config] Kernel config overrides
+ $0 package_source [file] Package source file information
EOF
}